diff --git a/libstdc++-v3/include/std/type_traits b/libstdc++-v3/include/std/type_traits
index b74565eb521..6108b98aa6a 100644
--- a/libstdc++-v3/include/std/type_traits
+++ b/libstdc++-v3/include/std/type_traits
@@ -1802,12 +1802,17 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
   // Primary template.
   /// make_unsigned
   template<typename _Tp>
+#if __cpp_concepts
+    requires is_integral<_Tp>::value || __is_enum(_Tp)
+#endif
     struct make_unsigned
     { typedef typename __make_unsigned_selector<_Tp>::__type type; };
 
   // Integral, but don't define.
-  template<>
-    struct make_unsigned<bool>;
+  template<> struct make_unsigned<bool>;
+  template<> struct make_unsigned<bool const>;
+  template<> struct make_unsigned<bool volatile>;
+  template<> struct make_unsigned<bool const volatile>;
 
   /// @cond undocumented
 
@@ -1932,12 +1937,17 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
   // Primary template.
   /// make_signed
   template<typename _Tp>
+#if __cpp_concepts
+    requires is_integral<_Tp>::value || __is_enum(_Tp)
+#endif
     struct make_signed
     { typedef typename __make_signed_selector<_Tp>::__type type; };
 
   // Integral, but don't define.
-  template<>
-    struct make_signed<bool>;
+  template<> struct make_signed<bool>;
+  template<> struct make_signed<bool const>;
+  template<> struct make_signed<bool volatile>;
+  template<> struct make_signed<bool const volatile>;
 
 #if __cplusplus > 201103L
   /// Alias template for make_signed
diff --git a/libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs_neg.cc b/libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs_neg.cc
index 051bb64c710..88b8ae887ef 100644
--- a/libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs_neg.cc
+++ b/libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs_neg.cc
@@ -20,31 +20,28 @@
 // <http://www.gnu.org/licenses/>.
 
 #include <type_traits>
-#include <testsuite_character.h>
 
-enum test_enum { first_selection };
+struct pod_class { };
 
 void test01()
 {
   using std::make_signed;
 
   // Negative tests.
-  typedef make_signed<bool>::type     	test1_type;
+  using T1 = make_signed<bool>::type; // { dg-error "incomplete" }
+  using T2 = make_signed<const bool>::type; // { dg-error "incomplete" }
+  using T3 = make_signed<volatile bool>::type; // { dg-error "incomplete" }
+  using T4 = make_signed<const volatile bool>::type; // { dg-error "incomplete" }
 
-  typedef make_signed<__gnu_test::pod_uint>::type     	test2_type;
+  using T5 = make_signed<pod_class>::type; // { dg-error "here" }
 
-  typedef make_signed<int[4]>::type     test3_type;
+  using T6 = make_signed<int[4]>::type; // { dg-error "here" }
 
-  typedef void (fn_type) ();
-  typedef make_signed<fn_type>::type  	test4_type;
+  using fn_type = void ();
+  using T7 = make_signed<fn_type>::type; // { dg-error "here" }
 
-  typedef make_signed<float>::type  	test5_type;
+  using T8 = make_signed<float>::type; // { dg-error "here" }
 }
 
-// { dg-error "invalid use of incomplete type" "" { target *-*-* } 32 }
-// { dg-error "required from here" "" { target *-*-* } 34 }
-// { dg-error "required from here" "" { target *-*-* } 36 }
-// { dg-error "required from here" "" { target *-*-* } 39 }
-// { dg-error "required from here" "" { target *-*-* } 41 }
-
-// { dg-error "invalid use of incomplete type" "" { target *-*-* } 0 }
+// { dg-error "invalid use of incomplete type" "" { target c++17_down } 0 }
+// { dg-error "constraint failure" "" { target c++20 } 0 }
diff --git a/libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs_neg.cc b/libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs_neg.cc
index ff98cc42ef7..50f15e7037c 100644
--- a/libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs_neg.cc
+++ b/libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs_neg.cc
@@ -21,7 +21,6 @@
 
 #include <type_traits>
 
-enum test_enum { first_selection };
 struct pod_class { };
 
 void test01()
@@ -29,22 +28,20 @@ void test01()
   using std::make_unsigned;
 
   // Negative tests.
-  typedef make_unsigned<bool>::type     	test1_type;
+  using T1 = make_unsigned<bool>::type; // { dg-error "incomplete" }
+  using T2 = make_unsigned<const bool>::type; // { dg-error "incomplete" }
+  using T3 = make_unsigned<volatile bool>::type; // { dg-error "incomplete" }
+  using T4 = make_unsigned<const volatile bool>::type; // { dg-error "incomplete" }
 
-  typedef make_unsigned<pod_class>::type     	test2_type;
+  using T5 = make_unsigned<pod_class>::type; // { dg-error "here" }
 
-  typedef make_unsigned<int[4]>::type     test3_type;
+  using T6 = make_unsigned<int[4]>::type; // { dg-error "here" }
 
-  typedef void (fn_type) ();
-  typedef make_unsigned<fn_type>::type  	test4_type;
+  using fn_type = void ();
+  using T7 = make_unsigned<fn_type>::type; // { dg-error "here" }
 
-  typedef make_unsigned<float>::type  		test5_type;
+  using T8 = make_unsigned<float>::type; // { dg-error "here" }
 }
 
-// { dg-error "invalid use of incomplete type" "" { target *-*-* } 32 }
-// { dg-error "required from here" "" { target *-*-* } 34 }
-// { dg-error "required from here" "" { target *-*-* } 36 }
-// { dg-error "required from here" "" { target *-*-* } 39 }
-// { dg-error "required from here" "" { target *-*-* } 41 }
-
-// { dg-error "invalid use of incomplete type" "" { target *-*-* } 0 }
+// { dg-error "invalid use of incomplete type" "" { target c++17_down } 0 }
+// { dg-error "constraint failure" "" { target c++20 } 0 }
diff --git a/libstdc++-v3/testsuite/24_iterators/range_access/range_access_cpp20_neg.cc b/libstdc++-v3/testsuite/24_iterators/range_access/range_access_cpp20_neg.cc
index c0825a58587..26c8ae0ee1e 100644
--- a/libstdc++-v3/testsuite/24_iterators/range_access/range_access_cpp20_neg.cc
+++ b/libstdc++-v3/testsuite/24_iterators/range_access/range_access_cpp20_neg.cc
@@ -46,4 +46,5 @@ test03()
   C c;
   std::ssize(c);  // { dg-error "no matching function" }
 }
-// { dg-error "incomplete type .*make_signed.*S" "" { target *-*-* } 0 }
+// { dg-error "incomplete type .*make_signed.*S" "" { target c++17_down } 0 }
+// { dg-error "constraint failure" "" { target c++20 } 0 }
diff --git a/libstdc++-v3/testsuite/lib/prune.exp b/libstdc++-v3/testsuite/lib/prune.exp
index d457e975218..6d0b77a8ccd 100644
--- a/libstdc++-v3/testsuite/lib/prune.exp
+++ b/libstdc++-v3/testsuite/lib/prune.exp
@@ -51,6 +51,7 @@ proc libstdc++-dg-prune { system text } {
     regsub -all "(^|\n)\[^\n\]*:   (recursively )?required \[^\n\]*" $text "" text
     regsub -all "(^|\n)\[^\n\]*:   . skipping \[0-9\]* instantiation contexts \[^\n\]*" $text "" text
     regsub -all "(^|\n)\[^\n\]*:   in .constexpr. expansion \[^\n\]*" $text "" text
+    regsub -all "(^|\n)\[^\n\]*:   in requirements  .with\[^\n\]*" $text "" text
     regsub -all "(^|\n)    inlined from \[^\n\]*" $text "" text
     # Why doesn't GCC need these to strip header context?
     regsub -all "(^|\n)In file included from \[^\n\]*" $text "" text